.\"	$Source: /afs/athena.mit.edu/astaff/project/krb5/doc/protocols/kerberos/RCS/types.defined.ms,v $
.\"	$Author: jtkohl $
.\"	$Id: types.defined.ms,v 1.33 90/12/19 17:07:32 jtkohl Exp $
.\"
.ds R# "$Id: types.defined.ms,v 1.33 90/12/19 17:07:32 jtkohl Exp $
.N: sec 1 predef_types "Predefined Data Types"
.LP
This section specifies the encodings and types for host
addresses, and other types where part of the encoding has been
specified independently from the Kerberos protocol. 
.N: sec 2 foo84 "Host address types"
.PP
All the values for the host address type with the most significant bit
set (1) are reserved for 
local use.  All the values with the most significant bit reset (0) are
reserved for officially assigned type fields and interpretations.
.PP
The values of the types for the following addresses are chosen to match
the defined
address family constants in the Berkeley Standard Distribution of Unix.
They can be found in <sys/socket.h> with symbolic names AF_xxx (where
xxx is an abbreviation of the address family name).
.PP
The ordering relation between addresses is determined by
comparing each octet of the address, in encoding order, until a
difference is encountered.  The ordering is the result
of the comparison of the last octets or the first pair of differing
octets, whichever comes first.
.SH
Internet addresses
.PP
Internet addresses are 32-bit (4-octet) quantities, encoded in MSB
order.
The type of internet addresses is two (2).
.D3
When determining address orderings and the addresses are equal when
either UDP or TCP ports are in use, the port numbers should be
treated as two-octet unsigned integers, and compared; the result of that
comparison is then used as the result of the comparison of the addresses.
.SH
CHAOSnet addresses
.PP
CHAOSnet addresses are 16-bit (2-octet) quantities, encoded in MSB
order.
The type of CHAOSnet addresses is five (5).
.SH
ISO addresses
.PP
ISO addresses are variable-length.  The type of ISO addresses is
seven (7).
.SH
Xerox Network Services (XNS) addresses
.PP
XNS addresses are 48-bit (6-octet) quantities, encoded in MSB
order.
The type of XNS addresses is six (6).
.SH
AppleTalk Datagram Delivery Protocol (DDP) addresses
.PP
AppleTalk DDP addresses consist of an 8-bit node number and a 16-bit
network number.  The first octet of the address is the node number; the
remaining two octets encode the network number in MSB order.
The type of AppleTalk DDP addresses is sixteen (16).
.SH
DECnet Phase IV addresses
.PP
DECnet Phase IV addresses are 16-bit addresses, encoded in LSB order.
The type of DECnet Phase IV addresses is twelve (12).
